/*****************************************************
 * Semestralni prace k predmetu AD7B36WPA
 * Nazev:       Evidence ucastniku ozdravnych pobytu
 * Zpracovala:  Radoslava Jandova
 * Username:    jandora1
 * Obor:        STM-SwI, 4. semestr 2010/2011 leto
 * Konzultace:  Radek Hubner
 * **************************************************/
/*****************************************************
 * ManagedBean pro "Ucastnika".
 ****************************************************/
package controller;

import java.util.List;
import util.JsfUtil;
import javax.ejb.EJB;
import javax.enterprise.context.RequestScoped;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ManagedProperty;
import model.Ucastnik;

@ManagedBean(name = "managedUcastnik")
@RequestScoped
public class ManagedUcastnik {

    @EJB
    private UcastnikDAO facade; //fasada
    private Ucastnik aktualUcastnik = new Ucastnik();
    @ManagedProperty(value = "#{param.aktualUcastnikId}")
    private Long aktualUcastnikId;
    
    /** Creates a new instance of Ucastnik */
    public ManagedUcastnik() {
    }

    public String create() {
        facade.create(aktualUcastnik);
        return "/ucastnik/listUcastnik";
    }

    public List<Ucastnik> getUcastnici() {
        return facade.findAll();
    }
    
    public String update() {

        try {
            facade.update(aktualUcastnik);
            JsfUtil.addSuccessMessage("Účastník změněn.");
            return "/ucastnik/listUcastnik";
        } catch (Exception e) {
            JsfUtil.addErrorMessage(e.toString());
            return null;
        }
    }

    public String delete() {
        facade.delete(aktualUcastnik.getId());
        return "/ucastnik/listUcastnik";
    }

    /**
     * @return the idUcastnika
     */
    public Long getIdUcastnika() {
        return aktualUcastnik.getId();
    }

    /**
     * @param idUcastnika the idUcastnika to set
     */
    public void setIdUcastnika(Long idUcastnika) {
        aktualUcastnik.setId(idUcastnika);
    }

    /**
     * @return the verzeUcastnika
     */
    public Integer getVerzeUcastnika() {
        return aktualUcastnik.getVerze();
    }

    /**
     * @param verzeUcastnika the verzeUcastnika to set
     */
    public void setVerzeUcastnika(Integer verzeUcastnika) {
        aktualUcastnik.setVerze(verzeUcastnika);
    }

    /**
     * @return the prijmeniUcastnika
     */
    public String getPrijmeniUcastnika() {
        return aktualUcastnik.getPrijmeni();
    }

    /**
     * @return the jmenoUcastnika
     */
    public String getJmenoUcastnika() {
        return aktualUcastnik.getJmeno();
    }

    /**
     * @return the mestoUcastnika
     */
    public String getMestoUcastnika() {
        return aktualUcastnik.getMesto();
    }

    /**
     * @param prijmeniUcastnika the prijmeniUcastnika to set
     */
    public void setPrijmeniUcastnika(String prijmeniUcastnika) {
        aktualUcastnik.setPrijmeni(prijmeniUcastnika);
    }

    /**
     * @param jmenoUcastnika the jmenoUcastnika to set
     */
    public void setJmenoUcastnika(String jmenoUcastnika) {
        aktualUcastnik.setJmeno(jmenoUcastnika);
    }

    /**
     * @param mestoUcastnika the mestoUcastnika to set
     */
    public void setMestoUcastnika(String mestoUcastnika) {
        aktualUcastnik.setMesto(mestoUcastnika);
    }

    /**
     * @param aktualUcastnikId the aktualUcastnikId to set
     */
    public void setAktualUcastnikId(Long aktualUcastnikId) {
        if (aktualUcastnikId != null) {
            aktualUcastnik = facade.find(aktualUcastnikId);
        }
    }

    /**
     * @return the aktualUcastnikId
     */
    public Long getAktualUcastnikId() {
        return aktualUcastnikId;
    }
}
