/*****************************************************
 * Semestralni prace k predmetu AD7B36WPA
 * Nazev:       Evidence ucastniku ozdravnych pobytu
 * Zpracovala:  Radoslava Jandova
 * Username:    jandora1
 * Obor:        STM-SwI, 4. semestr 2010/2011 leto
 * Konzultace:  Radek Hubner
 * **************************************************/
/*****************************************************
 * Operace nad entitou "Ucastnik".
 * Data Access Object - objekt pro pristup k datum.
 ****************************************************/
package controller;

import java.util.List;
import javax.annotation.security.RolesAllowed;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.OptimisticLockException;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;
import model.Ucastnik;

@Stateless
public class UcastnikDAO {

    @PersistenceContext
    EntityManager em;

    public UcastnikDAO() {
    }

    @RolesAllowed("koordinator")
    public void create(Ucastnik entita) {
        getEm().persist(entita);
    }

    @RolesAllowed("koordinator")
    public void update(Ucastnik entita) throws PobytyException {
        try {
            getEm().merge(entita);
        } catch (OptimisticLockException ex) {
            throw new PobytyException(ex);
        }
    }

    public EntityManager getEm() {
        return em;
    }

    public void delete(Long id) {
        Ucastnik d = (Ucastnik) getEm().find(Ucastnik.class, id);
        getEm().remove(d);
    }

    public Ucastnik find(Long id) {
        return (Ucastnik) getEm().find(Ucastnik.class, id);
    }

    public List<Ucastnik> findAll() {
        Query q = getEm().createQuery("SELECT d FROM UCASTNIK d");
        return q.getResultList();
    }

    public int pocetUcastniku() {
        Query q = getEm().createQuery("SELECT d FROM UCASTNIK d");
        return q.getResultList().size();
    }

    public List<Ucastnik> findFromMax(int from, int max) {

        Query q = getEm().createQuery("SELECT d FROM UCASTNIK d");
        q.setFirstResult(from);
        q.setMaxResults(max);
        return q.getResultList();
    }
}
