/*****************************************************
 * Semestralni prace k predmetu AD7B36WPA
 * Nazev:       Evidence ucastniku ozdravnych pobytu
 * Zpracovala:  Radoslava Jandova
 * Username:    jandora1
 * Obor:        STM-SwI, 4. semestr 2010/2011 leto
 * Konzultace:  Radek Hubner
 * **************************************************/
/*****************************************************
 * Popis ucastnika.
 * Framework pro pristup k databazi.
 ****************************************************/
package model;

import java.io.Serializable;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Version;

@Entity(name = "UCASTNIK")
public class Ucastnik implements Serializable {

    //Deklarace Atributu a promennych
    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;
    @Version
    private int verze;
    private String prijmeni;
    private String jmeno;
    private String mesto;

    //prazdny konstruktor - potrebuje ho system
    public Ucastnik() {
    }

    public Ucastnik(long id, int version, String prijmeni, String jmeno, String mesto) {
        this.id = id;
        this.verze = version;
        this.prijmeni = prijmeni;
        this.jmeno = jmeno;
        this.mesto = mesto;
    }

    public void setPrijmeni(String prijmeni) {
        this.prijmeni = prijmeni;
    }

    public void setJmeno(String jmeno) {
        this.jmeno = jmeno;
    }

    public void setMesto(String mesto) {
        this.mesto = mesto;
    }

    public String getPrijmeni() {
        return prijmeni;
    }

    public String getJmeno() {
        return jmeno;
    }

    public String getMesto() {
        return mesto;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Ucastnik)) {
            return false;
        }
        Ucastnik other = (Ucastnik) object;
        if ((this.id == null && other.id != null) || (this.id != null && !this.id.equals(other.id))) {
            return false;
        }
        return true;
    }

    public int getVerze() {
        return verze;
    }

    public void setVerze(int verze) {
        this.verze = verze;
    }

    @Override
    public String toString() {
        return String.format("Účastník[id: %d, verze: %d, prijmeni: %s, jmeno: %s, mesto: %s", id, verze, prijmeni, jmeno, mesto);
    }
}
